package compiler

import (
	"git.akyoto.dev/cli/q/src/asm"
	"git.akyoto.dev/cli/q/src/linux"
	"git.akyoto.dev/cli/q/src/register"
	"git.akyoto.dev/cli/q/src/token"
)

// Function represents a function.
type Function struct {
	Name      string
	Head      token.List
	Body      token.List
	Assembler asm.Assembler
}

// Compile turns a function into machine code.
func (f *Function) Compile() {
	for i, t := range f.Body {
		if t.Kind == token.Identifier && t.String() == "print" {
			message := f.Body[i+2].Bytes
			f.Assembler.MoveRegisterNumber(register.Syscall0, linux.Write)
			f.Assembler.MoveRegisterNumber(register.Syscall1, 1)
			f.Assembler.MoveRegisterData(register.Syscall2, message)
			f.Assembler.MoveRegisterNumber(register.Syscall3, uint64(len(message)))
			f.Assembler.Syscall()
		}
	}
}

// String returns the function name.
func (f *Function) String() string {
	return f.Name
}
